(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)











(*This IS an initialization cell.  
      Look at the slight change to the bracket to the right*)













InitModel=Module[{},
        (*Clear our parameter values:*)
        
        Clear[HACT,HACTp,As,kTa,nuTa,Pmax,kAt,nuAt,Ts,Htar,HTAR,Tmax];
        
        (*Clear our initial values:*)
        
        Clear[ACTinit,ACTpinit,tarinit,TARinit];
        
        (*Clear our dependent variables:*)
        Clear[ACT,ACTp,tar,TAR];
        
        (*Clear our independent variable and system of equations:*)
        
        Clear[cycle,t];
        
        (*Clear the end of integration:*)
        Clear[tend];
        
        
        (*Define our system:*)
        
        cycle = {ACT'[t]==
              ConstantSynthesis[As]-Degredation[ACT[t],HACT]-
                Phosphorylation[ACT[t],TAR[t],kTa,nuTa,Pmax],
            
            ACTp'[t]==
              Phosphorylation[ACT[t],TAR[t],kTa,nuTa,Pmax]-
                Degredation[ACTp[t],HACTp],
            
            tar'[t]\[Equal]Transcription[ACT[t]+ACTp[t],kAt,nuAt,Ts]-
                Degredation[tar[t],Htar],
            TAR'[t]\[Equal]Translation[tar[t],Tmax]-Degredation[TAR[t],HTAR],
            ACT[0]\[Equal]ACTinit,
            ACTp[0]\[Equal]ACTpinit,
            tar[0]\[Equal]tarinit,
            TAR[0]\[Equal]TARinit};
        
        dependentvariables={ACT[t],ACTp[t],tar[t],TAR[t]};
        
        (*Assign reasonable initial values to our paramters:*)
        
        HACT=60;HACTp=5;Htar=20;HTAR=20; (*Half lives*)
        
        kTa=0.5;nuTa=4;Pmax=1;(*Phosphorylation parameters*)
        
        kAt=0.5;nuAt=4;Ts=1/Htar;(*tar transcription parameters*)
        
        Tmax=1/HTAR;(*TAR translation parameters*)
        
        (*ACT synthesis rate:*)
        As=1/HACT;
        
        ACTinit=ACTpinit=tarinit=TARinit=0;(*Initial conditions*)
        
        (*Finally, 
          let's set the end time of integration here to something reasonable:*)

                tend = 1000;
        ]&;





InitAffectors=Module[{},
        (*Clear our affectors then define them:*)
        
        Clear[Degredation,Phi,Phosphorylation,ConstantSynthesis,Transcription,
          Translation];
        Degredation[molecule_,halflife_]:=molecule/halflife;
        Phi[protein_,k_,nu_]:=protein^nu/(k^nu+protein^nu);
        Phosphorylation[substrate_,kinase_,Kkinase_,nukinase_,maximalrate_]:=
          maximalrate substrate Phi[kinase,Kkinase,nukinase];
        ConstantSynthesis[rate_]:=rate;
        Transcription[activator_,Kactivator_,nuactivator_,maxrate_]:=
          Phi[activator,Kactivator,nuactivator]maxrate;
        Translation[mRNA_,translationrate_]:=mRNA translationrate;
        ]&;







Clear[SolveCycle];
SolveCycle[]:=
    NDSolve[cycle,dependentvariables,{t,0,tend},MaxSteps\[Rule]Round[20tend]];





Clear[PlotCycle];
PlotCycle=Module[{},
        Plot[Evaluate[{ACT[t]+ACTp[t],TAR[t]}/.#1],{t,0,tend},
            PlotRange\[Rule]{0,1},AxesLabel\[Rule]{"t","Conc"},
            PlotStyle\[Rule]{Red,Black},PlotLabel->"ACT red, TAR Black"];
        ]&;





Clear[PhasePlotCycle];
PhasePlotCycle=Module[{},
        ParametricPlot[Evaluate[{ACT[t]+ACTp[t],TAR[t]}/.#1],{t,0,tend},
            PlotRange\[Rule]{{0,1},{0,1}},AxesLabel\[Rule]{"ACT","TAR"}];
        ]&;





Clear[ScoreCycle];
ScoreCycle=Module[{},
        (*Start by solving the system:*)
        
        Return[{ScoreFunction[#1,ACT[t]+ACTp[t]],ScoreFunction[sol,TAR[t]]},
            Module];
        ]&;





Clear[ScoreFunction];
ScoreFunction=
    Module[{sol,var,localmaximavalues,localmaximatimes,localminimavalues,
          localminimatimes,i,oscillates,maxvalue,minvalue,period},
        sol = #1;
        var = #2;
        
        (*Start by converting our solution to a time plot with the points \
exactly 1 apart:*)
        
        value = Flatten[Table[Evaluate[var/.sol],{t,0,tend}]];
        
        (*Strategy:  find all the minima and maxima, 
          starting from the end and going backwards to tend/2:*)
        
        localmaximavalues = {};
        localmaximatimes={};
        localminimavalues = {};
        localminimatimes={};
        For[i=tend-1,i>tend/2,--i,{
            
            (*Test for local maximum.  
                  If it is local max then record time and value*)
            
            If[value[[i]]>value[[i+1]]&&value[[i]]>value[[i-1]],{
                AppendTo[localmaximavalues,value[[i]]];
                AppendTo[localmaximatimes,i];
                }];
            
            (*Test for local minimum.  
                  If it is local min then record time and value*)
            
            If[value[[i]]<value[[i+1]]&&value[[i]]<value[[i-1]],{
                AppendTo[localminimavalues,value[[i]]];
                AppendTo[localminimatimes,i];
                }];
            }];
        
        (*The variables below are going to be returned by our score function. \
 For now, 
          we assume we didn't get oscillations.  
              We'll change these if there are oscillations detected*)
        
        oscillates=False;
        maxvalue=0;
        minvalue=0;
        period=0;
        
        (*Assume we have oscillations if we have at least 2 maxima and 2 \
local minima in the last half of our run*)
        
        If[Length[localmaximavalues]\[GreaterEqual]2&&
            Length[localminimavalues]\[GreaterEqual]2,
          {
            (*Also require that the maximum must be at least 1% higher than \
the minimum and the period is longer than 4 time units*)
            
            If[localmaximavalues[[1]]/localminimavalues[[1]]>1.01&&
                  localmaximatimes[[1]]-localmaximatimes[[2]]>4,{
                  maxvalue=localmaximavalues[[1]];(*Last peak is the maximum*)

                                    
                  minvalue=
                    localminimavalues[[1]];(*Last valley is the minimum*)
    
                                
                  period=localmaximatimes[[1]]-
                      localmaximatimes[[2]];(*Period is the time between the \
last and second to last maxima*)
                  oscillates=True;
                  }];
            }];
        Return[{oscillates,maxvalue,minvalue,period},Module];
        ]&;





Clear[PrintScore];
PrintScore=Module[{ACTscore,TARscore},
        {ACTscore,TARscore}=#1;
        Print[
          "ACT+ACTp:  oscillates="<>ToString[ACTscore[[1]]]<>", peak value = "<>
            ToString[ACTscore[[2]]]<>", valley value = "<> 
            ToString[ACTscore[[3]]]<>", period = "<>ToString[ACTscore[[4]]]];
        Print[
          "TAR:      oscillates="<>ToString[TARscore[[1]]]<>", peak value = "<>
            ToString[TARscore[[2]]]<>", valley value = "<> 
            ToString[TARscore[[3]]]<>", period = "<>ToString[TARscore[[4]]]];
        ]&;







Clear[ Linsamp];
Linsamp[min_,max_]:=min+(max-min)Random[];





Clear[RandomParameterSet];
RandomParameterSet=Module[{},
        Hmin = 10;
        Hmax = 120;
        kmin = 0.025;
        kmax = 1.2;
        numin = 1;
        numax = 8;
        
        If[#1\[Equal]1,{
            (*Dimensional parameter values.  
                  We're varying all parameters over a wide range*)
           
             HACT=Linsamp[Hmin,Hmax];
            
            HACTp=Linsamp[0.1HACT,
                0.2HACT]; (*Constrain search so that ACTp is degraded faster \
than ACT*)
            Htar=Linsamp[Hmin,Hmax];
            HTAR=Linsamp[Hmin,Hmax];
            
            Pmax=Linsamp[kmin,kmax];
            kTa=Linsamp[kmin,kmax];
            kAt=Linsamp[kmin,kmax];
            nuTa=Linsamp[numin,numax];
            nuAt=Linsamp[numin,numax];
            
            Ts=1/Linsamp[Hmin,Hmax];
            Tmax=1/Linsamp[Hmin,Hmax];
            As=1/Linsamp[Hmin,Hmax];
            }];
        
        If[#1\[Equal]2,{
            (*Effectively nondimensionalized.  
                  Groupings between prameter values chosen so that ACT and \
TAR vary from 0 to 1 only.  
                  In this case Ts Tmax and As are redunant parameters and so \
we can just fix their values in relation to the half lives and still explore \
the full dynamics of this network.  
                  Thus we get rid of 3 redundant values and only have to \
randomize 9 parameters instead of 12. *)
            HACT=Linsamp[Hmin,Hmax];
            
            HACTp=Linsamp[0.1HACT,
                0.2HACT]; (*Constrain search so that ACTp is degraded faster \
than ACT*)
            Htar=Linsamp[Hmin,Hmax];
            HTAR=Linsamp[Hmin,Hmax];
            
            Pmax=Linsamp[kmin,kmax];
            kTa=Linsamp[kmin,kmax];
            kAt=Linsamp[kmin,kmax];
            nuTa=Linsamp[numin,numax];
            nuAt=Linsamp[numin,numax];
            
            Ts=1/Htar;
            Tmax=1/HTAR;
            As=1/HACT;
            }];
        ]&;





Clear[ReadParamValues];
ReadParamValues[]:={HACT,HACTp,As,kTa,nuTa,Pmax,kAt,nuAt,Ts,Htar,HTAR,Tmax};





Clear[WriteParamValues];
WriteParamValues=Module[{},
        {HACT,HACTp,As,kTa,nuTa,Pmax,kAt,nuAt,Ts,Htar,HTAR,Tmax}=#1;
        ]&;






Clear[PrintParamValues];
PrintParamValues=
    Module[{HACT,HACTp,As,kTa,nuTa,Pmax,kAt,nuAt,Ts,Htar,HTAR,Tmax},
        
        (*We want this function NOT to change the parameter values (just \
print them),so we define new local copies of our parameters.*)
        
        {HACT,HACTp,As,kTa,nuTa,Pmax,kAt,nuAt,Ts,Htar,HTAR,Tmax}=#1;
        
        (*Now, 
          print a nicely-
            formatted table of our values and a legend.  
                See TableForm help for more info.*)
        
        Print[TableForm[{{"HACT","HACTp","As","kTa","nuTa","Pmax","kAt","nuAt",
                "Ts","Htar","HTAR","Tmax"},{HACT,HACTp,As,kTa,nuTa,Pmax,kAt,
                nuAt,Ts,Htar,HTAR,Tmax}}]];
        ]&;





Clear[FindWorkingParamSets];
FindWorkingParamSets=Module[{},
        numsets =#1;
        numfound=0;
        workingsets=Table[{},{numsets}];
        workingscores=Table[{},{numsets}];
        While[numfound<numsets,
          {
            RandomParameterSet[2];
            sol=SolveCycle[];
            score = ScoreCycle[sol];
            
            If[score[[1,1]]\[Equal]True && score[[2,1]]\[Equal]True,{
                ++numfound;
                workingsets[[numfound]]=ReadParamValues[];
                workingscores[[numfound]]=score;
                }];
            }];
        Return[{workingsets,workingscores},Module];
        ]&;





Print["Loaded CycleFunctions.m"];



